/*================================================================================
	
	------------------------------------
	-*- [ZPNM] Human Classes Example -*-
	------------------------------------
	
	~~~~~~~~~~~~~~~
	- Description -
	~~~~~~~~~~~~~~~
	
	This is just an example on how to add additional human classes to ZPNM.
	
================================================================================*/

#include <amxmodx>
#include <zombieplaguenightmare>

// Human Attributes
new const hclass_name[] = "My Human" // name
new const hclass_info[] = "My Stats" // description
new const hclass_model[] = "leet" // model
new const hclass_handmodel[] = "v_knife.mdl" // hand model
const hclass_health = 100 // health
const hclass_speed = 240 // speed
const Float:hclass_gravity = 1.0 // gravity

// Class IDs
new g_hclassid1

// Human Classes MUST be registered on plugin_precache
public plugin_precache()
{
	register_plugin("[ZPNM] Additional Human Classes", "0.1", "Example")
	
	// Register the new class and store ID for reference
	g_hclassid1 = zpnm_register_human_class(hclass_name, hclass_info, hclass_model, hclass_handmodel, hclass_health, hclass_speed, hclass_gravity)	
}

// User spawn forward
public zpnm_user_spawn_post(id)
{
	// Check if the player is using our custom human class
	if (zpnm_get_user_human_class(id) == g_hclassid1)
	{
		client_print(id, print_chat, "[ZPNM] You're using a custom human class! Enjoy 57 extra HP!")
		zpnm_set_user_health(id, get_user_health(id) + 57)
	}
}

// User humanized forward
public zp_user_humanized_post(id)
{
	// Check if the player is using our custom human class
	if (zpnm_get_user_human_class(id) == g_hclassid1)
	{
		client_print(id, print_chat, "[ZPNM] You're using a custom human class! Enjoy 57 extra HP!")
		zpnm_set_user_health(id, get_user_health(id) + 57)
	}
}
