/*
To do:

T = needs testing
X = done
- = cancelled

[T] fixed wrong received armor amount printing
[T] update colored chat stock
[T] fix potential armor setting on zombie bug
[T] CZ bots support
v1.3.1
[T] only allow picking up a new armor if player has 0
[T] make sure armor is not set lower than 0
v1.3.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <cstrike>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

new g_iItemArmor, cvar_give, cvar_limit

new const g_szSoundsArmor[][] =
{
	"items/ammopickup1.wav",
	"items/ammopickup2.wav"
}
const g_iSizeSounds = sizeof g_szSoundsArmor - 1

new g_iArmor[33];

public plugin_init()
{
	register_plugin("[ZPNM] Anti-Infection Armor", "1.3.2", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_armor.txt")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
	RegisterHamBots(Ham_Spawn, "fw_PlayerSpawn_Post", 1)
	RegisterHamBots(Ham_Killed, "fw_PlayerKilled")
	
	cvar_give = register_cvar("zpnm_armor_amount", "100")
	cvar_limit = register_cvar("zpnm_armor_limit", "500")
	
	g_iItemArmor = zp_register_extra_item("Anti-infection armor", 11, ZP_TEAM_HUMAN)
}

public plugin_precache()
	for (new i; i <= g_iSizeSounds; i++)
		precache_sound(g_szSoundsArmor[i])
/*
public plugin_cfg()
{
	// Get configs dir
	new cfgdir[32]
	get_localinfo("amxx_configsdir", cfgdir, 31)
	
	// Execute config file (zpnm_sub_plugins.cfg)
	server_cmd("exec %s/zpnm_sub_plugins.cfg", cfgdir)
}*/

public client_disconnect(iID)
	g_iArmor[iID] = 0

public fw_PlayerSpawn_Post(const iID)
{
	if (!g_iArmor[iID] || !is_user_alive(iID))
		return;
	
	zpnm_give_armor(iID, g_iArmor[iID])
	
	g_iArmor[iID] = 0
}

public zp_user_infected_post(iID)
{
	g_iArmor[iID] = 0;
}

public zp_extra_item_selected(iID, itemid)
{
	if (itemid != g_iItemArmor)
		return PLUGIN_CONTINUE;
	
	new iLimit = get_pcvar_num(cvar_limit)
	
	if (iLimit && get_user_armor(iID) >= iLimit)
	{
		ftClientPrintChatColor(iID, iID, "^3%L", iID, "ZPNM_ARMOR_LIMIT", iLimit)
		
		return ZP_PLUGIN_HANDLED;
	}
	
	zpnm_give_armor(iID, get_pcvar_num(cvar_give))
	
	return PLUGIN_CONTINUE;
}

public fw_PlayerKilled(const iID)
	if (zp_has_round_started() == 2)
		g_iArmor[iID] = get_user_armor(iID)

zpnm_give_armor(const iID, iAmount)
{
	ftClientPrintChatColor(iID, iID, "^4%L", iID, "ZPNM_ARMOR_GET", iAmount)
	
	iAmount += get_user_armor(iID)
	
	if (iAmount > 0)
		cs_set_user_armor(iID, iAmount, CS_ARMOR_VESTHELM)
	else
		cs_set_user_armor(iID, 0, CS_ARMOR_NONE)
	
	emit_sound(iID, CHAN_BODY, g_szSoundsArmor[random_num(0, g_iSizeSounds)], 1.0, ATTN_NORM, 0, PITCH_NORM)
}

ftClientPrintChatColor(const iIDTarget, const iIDSender = 0, const szMessage[], any:...)
{
	if (iIDTarget && !is_user_connected(iIDTarget))
		return;
	
	static szBuffer[192];
	vformat(szBuffer, charsmax(szBuffer), szMessage, 4)
	
	static const szChatTag[] = "^1[^4ZPNM^1] ";
	format(szBuffer, charsmax(szBuffer), "%s%s", szChatTag, szBuffer)
	
	static iIDMsgSayText;
	if (!iIDMsgSayText)
		iIDMsgSayText = get_user_msgid("SayText");
	
	if (iIDTarget)
		message_begin(MSG_ONE, iIDMsgSayText, _, iIDTarget)
	else
		message_begin(MSG_ALL, iIDMsgSayText)
	
	write_byte(!iIDSender ? iIDTarget : iIDSender)
	write_string(szBuffer)
	message_end()
}
