/*
To do:

T = needs testing
X = done
- = cancelled

[X] avoid spamming entity creation/removal
[X] properly adjust entity vertical position for when user is(n't) crouching
[X] set entity angles to the ones of the user on freeze
[X] optimize
v0.1.9
[ ] customizable resources through external files
[ ] 
*/

// Modules
#include <amxmodx>
#include <engine>

// Plug-in APIs
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>



new const g_szModelFreeze[] = "sprites/674628.spr";

new g_iIDEntity[33], g_iBsFrozen;

public plugin_precache()
	precache_model(g_szModelFreeze)

public plugin_init()
{
	register_plugin("[ZPNM] Freeze effects", "0.1.9", "DareDevil, D i 5 7 i n c T, NiHiLaNTh")
	
	//register_clcmd("say /fz", "fwClCmdSay")
}
/*
public fwClCmdSay(const iID)
{
	if (!bitsum_get(g_iBsFrozen, iID))
		zpnm_set_user_frozen(iID, 1)
	else
		zpnm_set_user_frozen(iID, 0)
}*/

public client_disconnect(id)
{
	bitsum_del(g_iBsFrozen, id)
	
	//remove_task(id)
	
	if (g_iIDEntity[id])
	{
		remove_entity(g_iIDEntity[id])
		
		g_iIDEntity[id] = 0;
	}
}

public client_PreThink(id)
{
	if (!bitsum_get(g_iBsFrozen, id) || !g_iIDEntity[id])
		return;
	
	static Float:fVecOrigin[3];
	entity_get_vector(id, EV_VEC_origin, fVecOrigin);
	
	if (entity_get_int(id, EV_INT_flags) & FL_DUCKING)
		fVecOrigin[2] -= 18.0;
	else
		fVecOrigin[2] -= 36.0;
	
	entity_set_origin(g_iIDEntity[id], fVecOrigin)
}

public zpnm_user_frozen(id)
{
	bitsum_add(g_iBsFrozen, id)
	
	if (!g_iIDEntity[id])
	{
		g_iIDEntity[id] = create_entity("info_target");
		
		if (!is_valid_ent(g_iIDEntity[id]))
			return;
		
		entity_set_model(g_iIDEntity[id], g_szModelFreeze)
		entity_set_int(g_iIDEntity[id], EV_INT_body, 1)
		entity_set_size(g_iIDEntity[id], Float:{ -20.0, -20.0, -36.0 }, Float:{ 20.0, 20.0, 40.0 }) //17.0, 17.0, 36.0
		entity_set_int(g_iIDEntity[id], EV_INT_solid, SOLID_TRIGGER) //SOLID_BBOX
		//entity_set_int(g_iIDEntity[id], EV_INT_movetype, MOVETYPE_NOCLIP) //MOVETYPE_FLY MOVETYPE_FOLLOW
		//entity_set_edict(g_iIDEntity[id], EV_ENT_aiment, id); //necessary for MOVETYPE_FOLLOW
		set_rendering(g_iIDEntity[id], kRenderFxNone, 255, 255, 255, kRenderTransAdd, 255)
	}
	else
	{
		entity_set_int(g_iIDEntity[id], EV_INT_effects, (entity_get_int(g_iIDEntity[id], EV_INT_effects) & ~EF_NODRAW))
	}
	
	static Float:fVecAngles[3];
	entity_get_vector(id, EV_VEC_angles, fVecAngles)
	fVecAngles[0] = 0.0;
	
	entity_set_vector(g_iIDEntity[id], EV_VEC_angles, fVecAngles)
	
	client_PreThink(id)
/*	
	static iVecOrigin[3];
	get_user_origin(id, iVecOrigin)
	
	fwTaskDlight(iVecOrigin, id)
	set_task(1.0, "fwTaskDlight", id, iVecOrigin, 3, "b")*/
}
/*
public fwTaskDlight(const iVecOrigin[3], const id)
{
	message_begin(MSG_PVS, SVC_TEMPENTITY, iVecOrigin)
	write_byte(TE_DLIGHT) // TE id
	write_coord(iVecOrigin[0]) // x
	write_coord(iVecOrigin[1]) // y
	write_coord(iVecOrigin[2]) // z
	write_byte(7) // radius
	write_byte(0) // r
	write_byte(100) // g
	write_byte(200) // b
	write_byte(11) // life
	write_byte(0) // decay rate
	message_end()
}*/

public zp_user_unfrozen(id)
{
	bitsum_del(g_iBsFrozen, id)
	
	//remove_task(id)
	
	if (g_iIDEntity[id])
		entity_set_int(g_iIDEntity[id], EV_INT_effects, (entity_get_int(g_iIDEntity[id], EV_INT_effects) | EF_NODRAW))
}

public zpnm_user_spawn_post(id)
{
	zp_user_unfrozen(id, 0)
}

public zpnm_user_killed_pre(id)
{
	client_disconnect(id)
}
