/*================================================================================
	
	----------------------------------
	-*- [ZPNM] Sub-Plugin: Rewards -*-
	----------------------------------
	
	~~~~~~~~~~~~~~~
	- Description -
	~~~~~~~~~~~~~~~
	
	This plugin offers certain amounts of ammo packs
		to those who frag their enemies or win the round.
	Everything is configurable by cvar values.
	This is a plugin that shouldn't be missing
		from any Zombie Plague server out there...
	Enjoy it and have fun!
	
	Original forum thread: http://forums.alliedmods.net/showthread.php?p=1156585
	
	~~~~~~~~~~~~~
	- Thanks to -
	~~~~~~~~~~~~~
	
		MeRcyLeZZ - For such an awesome mod like Zombie Plague
			and for some code i used from it...once again
		XxAvalanchexX - For some code i used from his GunGame Mod
		Fry! and bmann_420 - For not ignoring me when i
			needed help the most (like other 'friends' do)
		suNx - For helping me with the plugin tests
		abdul-rehman - For being a good friend
	
	~~~~~~~~~~~~~
	- Changelog -
	~~~~~~~~~~~~~
	
	* v1.0 (21 Apr 2010)
		- First release
	
	* v1.1 (21 Apr 2010)
		- Fixed plugin turning off when
		the toggle cvar is set to 1
		- Added rewards for surviving
		the round as Nemesis or Survivor
		- Removed unuseful cvars
	
	* v1.2 (22 Apr 2010)
		- Fixed players not getting ammo packs when fragging a enemy
			(rescripted the Player Killed part in the plugin)
		     This wasn't showing up because i was testing the plugin
			with bots and it seems that just human players count
		- Added giving the players rewards in other rounds
	
	* v1.3 (10 May 2010)
		- Fixed bug where a player that killed Nemesis got packs for
			a Zombie frag too. Well, Nemesis is just a fancy Zombie...
		- Fixed players not getting awards for winning
			other rounds than Nemesis or Survivor
		- Added knife kill rewards for Survivors and Humans
		- Added chat text to notify when a Nemesis
			or a Zombie kills or infects a Human
		- Fixed chat multiple print bug
		- Fixed tons of other chat print bugs
	
	* v1.4 (23 Jun 2010)
		- Made the plugin multi-lingual
		- Added rewards for killing the first and last Zombie
		- Added reward giving for killing the last Human
		- Improved some code
		- Fixed some chat print errors
		- Fixed bug where sometimes bazooka kills
			were considered knife kills
	
	* v1.5 (12 Jun 2012)
		- Totally rewritten the plugin
		- Ported to Zombie Plague Nightmare
	
================================================================================*/

/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] zpnm_get_user_alive/connected -> is_user_alive/connected
v1.5.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

// Make sure it's a real knife kill
const m_bitsDamageType = 76

enum rewards
{
	zombie = 0,
	first,
	lastz,
	nemesis,
	assassin,
	human,
	lasth,
	survivor,
	sniper,
	knife,
	round
}

new g_reward[knife][rewards], g_chat[10], g_name[33][32], g_participated[33]

// Cvars
new cvar_zkih, cvar_fzkih, cvar_lzkih, cvar_nkh, cvar_akh, cvar_hkz, cvar_lhkz, cvar_svkz, cvar_spkz

// Get server's max players
new g_maxplayers

public plugin_init()
{
	register_plugin("[ZPNM] Rewards", "1.5.3", "D i 5 7 i n c T")
	register_dictionary("zpnm_rewards.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	//	hm, lhm, sv, sp, round, chat
	cvar_zkih = register_cvar("zpnm_rewards_zombie", "0 1 35 57 1 1")
	cvar_fzkih = register_cvar("zpnm_rewards_zombie_first", "0 3 35 57 3 1")
	cvar_lzkih = register_cvar("zpnm_rewards_zombie_last", "0 1 39 75 3 1")
	cvar_nkh = register_cvar("zpnm_rewards_nemesis", "0 1 5 7 35 1")
	cvar_akh = register_cvar("zpnm_rewards_assassin", "0 1 3 5 35 1")
	
	// zm, fzm, lzm, nms, ass, knife, round, chat
	cvar_hkz = register_cvar("zpnm_rewards_human", "1 1 3 35 57 35 1 1")
	cvar_lhkz = register_cvar("zpnm_rewards_human_last", "3 3 5 39 75 57 11 1")
	cvar_svkz = register_cvar("zpnm_rewards_survivor", "1 1 1 3 5 19 35 1")
	cvar_spkz = register_cvar("zpnm_rewards_sniper", "1 1 1 3 3 17 31 1")
	
	g_maxplayers = get_maxplayers()
}

public plugin_cfg()
	set_task(0.357, "cache_settings")

public cache_settings()
{
	static cvars[72], value1[10], value2[10], value3[10], value4[10], value5[10], value6[10], value7[10], value8[2]
	
	get_pcvar_string(cvar_zkih, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value8, 1)
	g_reward[zombie][human] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[zombie][lasth] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[zombie][survivor] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[zombie][sniper] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[zombie][round] = clamp(str_to_num(value5), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[zombie] = true
	else
		g_chat[zombie] = false
	
	get_pcvar_string(cvar_fzkih, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value8, 1)
	g_reward[first][human] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[first][lasth] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[first][survivor] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[first][sniper] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[first][round] = clamp(str_to_num(value5), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[first] = true
	else
		g_chat[first] = false
	
	get_pcvar_string(cvar_lzkih, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value8, 1)
	g_reward[lastz][human] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[lastz][lasth] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[lastz][survivor] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[lastz][sniper] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[lastz][round] = clamp(str_to_num(value5), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[lastz] = true
	else
		g_chat[lastz] = false
	
/*	// 0 - nimic 0
	// 1 - killer 2^0
	// 2 - vicitima 2^1
	// 4 - restu 2^2
	
	new bitsum;
	if(bitsum)
	{

		if(bitsum & (1 << 1)) //kiler
			printeaza la spartu de a facut killu
		if(bitsum & (1 << 2)) // victima
			printeaza la victima
		if(bitsum & (1 << 3)) // toti plm
			{
				new i;
				for(i=1,n=0,p=5;i<=32;++i)
				{
				}
			i=3;
			afisez i++; 3
			afisez ++i; 4
				
	
	*/
	get_pcvar_string(cvar_nkh, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value8, 1)
	g_reward[nemesis][human] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[nemesis][lasth] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[nemesis][survivor] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[nemesis][sniper] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[nemesis][round] = clamp(str_to_num(value5), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[nemesis] = true
	else
		g_chat[nemesis] = false
	
	get_pcvar_string(cvar_akh, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value8, 1)
	g_reward[assassin][human] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[assassin][lasth] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[assassin][survivor] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[assassin][sniper] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[assassin][round] = clamp(str_to_num(value5), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[assassin] = true
	else
		g_chat[assassin] = false
	
	if (g_reward[zombie][human] || g_reward[nemesis][human] || g_reward[assassin][human])
		set_pcvar_num(get_cvar_pointer("zp_zombie_infect_reward"), 0)
	
	get_pcvar_string(cvar_hkz, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value6, 10, value7, 10, value8, 1)
	g_reward[human][zombie] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[human][first] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[human][lastz] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[human][nemesis] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[human][assassin] = clamp(str_to_num(value5), 0, 2147483646)
	g_reward[human][knife] = clamp(str_to_num(value6), 0, 2147483646)
	g_reward[human][round] = clamp(str_to_num(value7), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[human] = true
	else
		g_chat[human] = false
	
	get_pcvar_string(cvar_lhkz, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value6, 10, value7, 10, value8, 1)
	g_reward[lasth][zombie] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[lasth][first] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[lasth][lastz] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[lasth][nemesis] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[lasth][assassin] = clamp(str_to_num(value5), 0, 2147483646)
	g_reward[lasth][knife] = clamp(str_to_num(value6), 0, 2147483646)
	g_reward[lasth][round] = clamp(str_to_num(value7), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[lasth] = true
	else
		g_chat[lasth] = false
	
	get_pcvar_string(cvar_svkz, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value6, 10, value7, 10, value8, 1)
	g_reward[survivor][zombie] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[survivor][first] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[survivor][lastz] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[survivor][nemesis] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[survivor][assassin] = clamp(str_to_num(value5), 0, 2147483646)
	g_reward[survivor][knife] = clamp(str_to_num(value6), 0, 2147483646)
	g_reward[survivor][round] = clamp(str_to_num(value7), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[survivor] = true
	else
		g_chat[survivor] = false
	
	get_pcvar_string(cvar_spkz, cvars, 71)
	parse(cvars, value1, 10, value2, 10, value3, 10, value4, 10, value5, 10, value6, 10, value7, 10, value8, 1)
	g_reward[sniper][zombie] = clamp(str_to_num(value1), 0, 2147483646)
	g_reward[sniper][first] = clamp(str_to_num(value2), 0, 2147483646)
	g_reward[sniper][lastz] = clamp(str_to_num(value3), 0, 2147483646)
	g_reward[sniper][nemesis] = clamp(str_to_num(value4), 0, 2147483646)
	g_reward[sniper][assassin] = clamp(str_to_num(value5), 0, 2147483646)
	g_reward[sniper][knife] = clamp(str_to_num(value6), 0, 2147483646)
	g_reward[sniper][round] = clamp(str_to_num(value7), 0, 2147483646)
	
	if (str_to_num(value8))
		g_chat[sniper] = true
	else
		g_chat[sniper] = false
}

public client_infochanged(id)
{
	if (!is_user_connected(id))
		return;
	
	get_user_info(id, "name", g_name[id], 31)
}

public client_disconnect(id)
	g_participated[id] = false

public zpnm_user_spawn_post(id)
	g_participated[id] = true

public fwHamKilledPlayer(const vt, const atc)
{
	if (zp_has_round_started() != 1)
		g_participated[vt] = false
	
	if (!is_user_connected(atc))
		return;
	
	if (vt == atc)
		return;
	
	if (!zp_get_user_zombie(atc))
	{
		if (!zp_get_user_survivor(atc))
		{
			if (!zpnm_get_user_sniper(atc))
			{
				if (!zp_get_user_last_human(atc))
				{
					if (!zp_get_user_nemesis(vt))
					{
						if (!zpnm_get_user_assassin(vt))
						{
							if (!zp_get_user_last_zombie(vt))
							{
								if (!zp_get_user_first_zombie(vt))
								{
									if (!g_reward[human][zombie])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][zombie])
									
									if (!g_chat[human])
										return;
									
									zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[human][zombie], g_name[vt])
								}
								else
								{
									if (!g_reward[human][first])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][first])
									
									if (!g_chat[human])
										return;
									
									zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[human][first], g_name[vt], LANG_PLAYER, "ZPNM_FIRST")
								}
							}
							else
							{
								if (!g_reward[human][lastz])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][lastz])
								
								if (!g_chat[human])
									return;
								
								zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[human][lastz], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
							}
						}
						else
						{
							if (!g_reward[human][assassin])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][assassin])
							
							if (!g_chat[human])
								return;
							
							zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_HKA", g_name[atc], g_reward[human][assassin], g_name[vt])
						}
					}
					else
					{
						if (!g_reward[human][nemesis])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][nemesis])
						
						if (!g_chat[human])
							return;
						
						zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_HKN", g_name[atc], g_reward[human][nemesis], g_name[vt])
					}
				}
				else
				{
					if (!zp_get_user_nemesis(vt))
					{
						if (!zpnm_get_user_assassin(vt))
						{
							if (!zp_get_user_last_zombie(vt))
							{
								if (!zp_get_user_first_zombie(vt))
								{
									if (!g_reward[lasth][zombie])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][zombie])
									
									if (!g_chat[lasth])
										return;
									
									zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[lasth][zombie], g_name[vt])
								}
								else
								{
									if (!g_reward[lasth][first])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][first])
									
									if (!g_chat[lasth])
										return;
									
									zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[lasth][first], g_name[vt], LANG_PLAYER, "ZPNM_FIRST")
								}
							}
							else
							{
								if (!g_reward[lasth][lastz])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][lastz])
								
								if (!g_chat[lasth])
									return;
								
								zp_colored_print(0, "%L%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_HKZ", g_name[atc], g_reward[lasth][lastz], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
							}
						}
						else
						{
							if (!g_reward[lasth][assassin])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][assassin])
							
							if (!g_chat[lasth])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_HKA", g_name[atc], g_reward[lasth][assassin], g_name[vt])
						}
					}
					else
					{
						if (!g_reward[lasth][nemesis])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][nemesis])
						
						if (!g_chat[lasth])
							return;
						
						zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_HKN", g_name[atc], g_reward[lasth][nemesis], g_name[vt])
					}
				}
			}
			else
			{
				if (!zp_get_user_nemesis(vt))
				{
					if (!zpnm_get_user_assassin(vt))
					{
						if (!zp_get_user_last_zombie(vt))
						{
							if (!zp_get_user_first_zombie(vt))
							{
								if (!g_reward[sniper][zombie])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][zombie])
								
								if (!g_chat[sniper])
									return;
								
								zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SPKZ", g_name[atc], g_reward[sniper][zombie], g_name[vt])
							}
							else
							{
								if (!g_reward[sniper][first])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][first])
								
								if (!g_chat[sniper])
									return;
								
								zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_SPKZ", g_name[atc], g_reward[sniper][first], g_name[vt], LANG_PLAYER, "ZPNM_FIRST")
							}
						}
						else
						{
							if (!g_reward[sniper][lastz])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][lastz])
						
							if (!g_chat[sniper])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_SPKZ", g_name[atc], g_reward[sniper][lastz], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
						}
					}
					else
					{
						if (!g_reward[sniper][assassin])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][assassin])
						
						if (!g_chat[sniper])
							return;
						
						zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SPKA", g_name[atc], g_reward[sniper][assassin], g_name[vt])
					}
				}
				else
				{
					if (!g_reward[sniper][nemesis])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][nemesis])
					
					if (!g_chat[sniper])
						return;
					
					zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SPKN", g_name[atc], g_reward[sniper][nemesis], g_name[vt])
				}
			}
		}
		else
		{
			if (!zp_get_user_nemesis(vt))
			{
				if (!zpnm_get_user_assassin(vt))
				{
					if (!zp_get_user_last_zombie(vt))
					{
						if (!zp_get_user_first_zombie(vt))
						{
							if (!g_reward[survivor][zombie])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][zombie])
							
							if (!g_chat[survivor])
								return;
							
							zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SVKZ", g_name[atc], g_reward[survivor][zombie], g_name[vt])
						}
						else
						{
							if (!g_reward[survivor][first])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][first])
							
							if (!g_chat[survivor])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_SVKZ", g_name[atc], g_reward[survivor][first], g_name[vt], LANG_PLAYER, "ZPNM_FIRST")
						}
					}
					else
					{
						if (!g_reward[survivor][lastz])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][lastz])
						
						if (!g_chat[survivor])
							return;
						
						zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_SVKZ", g_name[atc], g_reward[survivor][lastz], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
					}
				}
				else
				{
					if (!g_reward[survivor][assassin])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][assassin])
					
					if (!g_chat[survivor])
						return;
					
					zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SVKA", g_name[atc], g_reward[survivor][assassin], g_name[vt])
				}
			}
			else
			{
				if (!g_reward[survivor][nemesis])
					return;
				
				zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][nemesis])
				
				if (!g_chat[survivor])
					return;
				
				zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_SVKN", g_name[atc], g_reward[survivor][nemesis], g_name[vt])
			}
		}
		
		if (get_user_weapon(atc) != CSW_KNIFE || get_pdata_int(vt, m_bitsDamageType) != (DMG_BULLET | DMG_NEVERGIB))
			return;
		
		if (!zp_get_user_survivor(atc))
		{
			if (!zpnm_get_user_sniper(atc))
			{
				if (!zp_get_user_last_human(atc))
				{
					if (!g_reward[human][knife])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[human][knife])
					
					if (!g_chat[human])
						return;
					
					zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_KNIFE", g_name[atc], g_reward[human][knife])
				}
				else
				{
					if (!g_reward[lasth][knife])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lasth][knife])
					
					if (!g_chat[lasth])
						return;
					
					zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_KNIFE", g_name[atc], g_reward[lasth][knife])
				}
			}
			else
			{
				if (!g_reward[sniper][knife])
					return;
				
				zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[sniper][knife])
				
				if (!g_chat[sniper])
					return;
				
				zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_KNIFE", g_name[atc], g_reward[sniper][knife])
			}
		}
		else
		{
			if (!g_reward[survivor][knife])
				return;
			
			zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[survivor][knife])
			
			if (!g_chat[survivor])
				return;
			
			zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_KNIFE", g_name[atc], g_reward[survivor][knife])
		}
	}
	else
	{
		if (!zp_get_user_nemesis(atc))
		{
			if (!zpnm_get_user_assassin(atc))
			{
				if (!zp_get_user_last_zombie(atc))
				{
					if (!zp_get_user_first_zombie(atc))
					{
						if (!zp_get_user_survivor(vt))
						{
							if (!zpnm_get_user_sniper(vt))
							{
								if (!zp_get_user_last_human(vt))
								{
									if (!g_reward[zombie][human])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[zombie][human])
									
									if (!g_chat[zombie])
										return;
									
									zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[zombie][human], g_name[vt])
								}
								else
								{
									if (!g_reward[zombie][lasth])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[zombie][lasth])
									
									if (!g_chat[zombie])
										return;
									
									zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[zombie][lasth], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
								}
							}
							else
							{
								if (!g_reward[zombie][sniper])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[zombie][sniper])
								
								if (!g_chat[zombie])
									return;
								
								zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_ZKSP", g_name[atc], g_reward[zombie][sniper], g_name[vt])
							}
						}
						else
						{
							if (!g_reward[zombie][survivor])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[zombie][survivor])
							
							if (!g_chat[zombie])
								return;
							
							zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_ZKSV", g_name[atc], g_reward[zombie][survivor], g_name[vt])
						}
					}
					else
					{
						if (!zp_get_user_survivor(vt))
						{
							if (!zpnm_get_user_sniper(vt))
							{
								if (!zp_get_user_last_human(vt))
								{
									if (!g_reward[first][human])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[first][human])
									
									if (!g_chat[first])
										return;
									
									zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_FIRST", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[first][human], g_name[vt])
								}
								else
								{
									if (!g_reward[first][lasth])
										return;
									
									zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[first][lasth])
									
									if (!g_chat[first])
										return;
									
									zp_colored_print(0, "%L%L%L", LANG_PLAYER, "ZPNM_FIRST", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[first][lasth], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
								}
							}
							else
							{
								if (!g_reward[first][sniper])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[first][sniper])
								
								if (!g_chat[first])
									return;
								
								zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_FIRST", LANG_PLAYER, "ZPNM_ZKSP", g_name[atc], g_reward[first][sniper], g_name[vt])
							}
						}
						else
						{
							if (!g_reward[first][survivor])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[first][survivor])
							
							if (!g_chat[first])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_FIRST", LANG_PLAYER, "ZPNM_ZKSV", g_name[atc], g_reward[first][survivor], g_name[vt])
						}
					}
				}
				else
				{
					if (!zp_get_user_survivor(vt))
					{
						if (!zpnm_get_user_sniper(vt))
						{
							if (!zp_get_user_last_human(vt))
							{
								if (!g_reward[lastz][human])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lastz][human])
								
								if (!g_chat[lastz])
									return;
								
								zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[lastz][human], g_name[vt])
							}
							else
							{
								if (!g_reward[lastz][lasth])
									return;
								
								zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lastz][lasth])
								
								if (!g_chat[lastz])
									return;
								
								zp_colored_print(0, "%L%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_ZKH", g_name[atc], g_reward[lastz][lasth], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
							}
						}
						else
						{
							if (!g_reward[lastz][sniper])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lastz][sniper])
							
							if (!g_chat[lastz])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_ZKSP", g_name[atc], g_reward[lastz][sniper], g_name[vt])
						}
					}
					else
					{
						if (!g_reward[lastz][survivor])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[lastz][survivor])
						
						if (!g_chat[lastz])
							return;
						
						zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_ZKSV", g_name[atc], g_reward[lastz][survivor], g_name[vt])
					}
				}
			}
			else
			{
				if (!zp_get_user_survivor(vt))
				{
					if (!zpnm_get_user_sniper(vt))
					{
						if (!zp_get_user_last_human(vt))
						{
							if (!g_reward[assassin][human])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[assassin][human])
							
							if (!g_chat[assassin])
								return;
							
							zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_AKH", g_name[atc], g_reward[assassin][human], g_name[vt])
						}
						else
						{
							if (!g_reward[assassin][lasth])
								return;
							
							zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[assassin][lasth])
							
							if (!g_chat[assassin])
								return;
							
							zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_AKH", g_name[atc], g_reward[assassin][lasth], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
						}
					}
					else
					{
						if (!g_reward[assassin][sniper])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[assassin][sniper])
						
						if (!g_chat[assassin])
							return;
						
						zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_AKSP", g_name[atc], g_reward[assassin][sniper], g_name[vt])
					}
				}
				else
				{
					if (!g_reward[assassin][survivor])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[assassin][survivor])
					
					if (!g_chat[assassin])
						return;
					
					zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_AKSV", g_name[atc], g_reward[assassin][survivor], g_name[vt])
				}
			}
		}
		else
		{
			if (!zp_get_user_survivor(vt))
			{
				if (!zpnm_get_user_sniper(vt))
				{
					if (!zp_get_user_last_human(vt))
					{
						if (!g_reward[nemesis][human])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[nemesis][human])
						
						if (!g_chat[nemesis])
							return;
						
						zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_NKH", g_name[atc], g_reward[nemesis][human], g_name[vt])
					}
					else
					{
						if (!g_reward[nemesis][lasth])
							return;
						
						zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[nemesis][lasth])
						
						if (!g_chat[nemesis])
							return;
						
						zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_NKH", g_name[atc], g_reward[nemesis][lasth], g_name[vt], LANG_PLAYER, "ZPNM_LAST")
					}
				}
				else
				{
					if (!g_reward[nemesis][sniper])
						return;
					
					zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[nemesis][sniper])
					
					if (!g_chat[nemesis])
						return;
					
					zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_NKSP", g_name[atc], g_reward[nemesis][sniper], g_name[vt])
				}
			}
			else
			{
				if (!g_reward[nemesis][survivor])
					return;
				
				zp_set_user_ammo_packs(atc, zp_get_user_ammo_packs(atc) + g_reward[nemesis][survivor])
				
				if (!g_chat[nemesis])
					return;
				
				zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_NKSV", g_name[atc], g_reward[nemesis][survivor], g_name[vt])
			}
		}
	}
}
			
// ZP User Infected Forward
public zp_user_infected_post(id, infector, nemesis, assassin)
{
	if (!infector || nemesis || assassin)
		return;
	
	if (!zp_get_user_last_zombie(infector))
	{
		if (!zp_get_user_first_zombie(infector))
		{
			if (!g_reward[zombie][human])
				return;
			
			zp_set_user_ammo_packs(infector, zp_get_user_ammo_packs(infector) + g_reward[zombie][human])
			zp_colored_print(0, "%L", LANG_PLAYER, "ZPNM_ZIH", g_name[infector], g_reward[zombie][human], g_name[id])
		}
		else
		{
			if (!g_reward[first][human])
				return;
			
			zp_set_user_ammo_packs(infector, zp_get_user_ammo_packs(infector) + g_reward[first][human])
			zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_FIRST", LANG_PLAYER, "ZPNM_ZIH", g_name[infector], g_reward[first][human], g_name[id])
		}
	}
	else
	{
		if (!g_reward[lastz][human])
			return;
		
		zp_set_user_ammo_packs(infector, zp_get_user_ammo_packs(infector) + g_reward[lastz][human])
		zp_colored_print(0, "%L%L", LANG_PLAYER, "ZPNM_LAST", LANG_PLAYER, "ZPNM_ZIH", g_name[infector], g_reward[lastz][human], g_name[id])
	}
}

// ZP Round Ended Forward
public zp_round_ended(winteam)
{
	// No one won...
	if (winteam == WIN_NO_ONE)
		return;
	
	// Loop trough all the players
	static id
	
	// Zombies have conquered the world
	if (winteam == WIN_ZOMBIES)
	{
		// Was Nemesis round
		if (zp_is_nemesis_round())
		{
			// Option turned off
			if (!g_reward[nemesis][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Nemesis
				if (is_user_alive(id) && zp_get_user_nemesis(id))
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[nemesis][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_NROUND", g_reward[nemesis][round])
			}
		}
		else if (zpnm_is_assassin_round())
		{
			// Option turned off
			if (!g_reward[assassin][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Assassin
				if (is_user_alive(id) && zpnm_get_user_assassin(id))
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[assassin][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_AROUND", g_reward[assassin][round])
			}
		}
		// Other rounds
		else
		{
			// Option turned off
			if (!g_reward[zombie][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Zombie
				if (zp_get_user_zombie(id) && g_participated[id])
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[zombie][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_ZROUND", g_reward[zombie][round])
			}
		}
	}
	// Humans survived
	else if (winteam == WIN_HUMANS)
	{
		// Was Survivor round
		if (zp_is_survivor_round())
		{
			// Option turned off
			if (!g_reward[survivor][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Survivor
				if (is_user_alive(id) && zp_get_user_survivor(id))
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[survivor][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_SVROUND", g_reward[survivor][round])
			}
		}
		else if (zpnm_is_sniper_round())
		{
			// Option turned off
			if (!g_reward[sniper][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Sniper
				if (is_user_alive(id) && zpnm_get_user_sniper(id))
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[sniper][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_SPROUND", g_reward[sniper][round])
			}
		}
		// Other rounds
		else
		{
			// Option turned off
			if (!g_reward[human][round])
				return;
			
			for (id = 1; id <= g_maxplayers; id++)
			{
				if (!is_user_connected(id))
					continue;
				
				// Is Human
				if (!zp_get_user_zombie(id) && g_participated[id])
					zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id) + g_reward[human][round])
				
				zp_colored_print(id, "%L", id, "ZPNM_HROUND", g_reward[human][round])
			}
		}
	}
}
