/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.8.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>
#include <geoip>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <amxmisc>

new const D7_CHAT_TAG[] = "^1[^4ZPNM^1]";

// Leave empty for no additional tag when having access to colored chat
new const D7_CHAT_SPECIAL_TAG[] = ""; //[^4VIP^1]

new const g_szSoundNormal[] = "misc/talk";
new g_bIsMp3SoundNormal;

new const g_szSoundSpecial[] = "events/tutor_msg";
new g_bIsMp3SoundSpecial;

new g_iMaxPlayers; // max server players
new g_szMlStatus[33][16]; // player status
new g_szClass[33][32]; // class string
new g_szName[33][31]; // player name
new g_szColor[33][2]; // admin colored chat string
new g_bCanChat[33]; // anti flood
new Float:g_fFloodTime; // interval necessary for considering player as spamming
new g_szCountry[33][4]; // player short country name
new g_iTeam[33]; // player team
new g_bAlive[33]; // whether the player is alive or not

public plugin_precache()
{
	g_bIsMp3SoundNormal = equali(g_szSoundNormal[strlen(g_szSoundNormal) - 4], ".mp3") ? true : false;
	g_bIsMp3SoundSpecial = equali(g_szSoundSpecial[strlen(g_szSoundSpecial) - 4], ".mp3") ? true : false;
	
	if (!g_bIsMp3SoundNormal || !g_bIsMp3SoundSpecial)
	{
/*		const iSizeSounds = (sizeof g_szSoundNormal) < (sizeof g_szSoundSpecial) ? (sizeof g_szSoundSpecial) : (sizeof g_szSoundNormal);
		*/
		new szSound[64/*iSizeSounds*/];
		
		if (!g_bIsMp3SoundNormal)
		{
			formatex(szSound, 63/*iSizeSounds - 1*/, "%s.wav", g_szSoundNormal)
			precache_sound(szSound)
		}
		
		if (!g_bIsMp3SoundSpecial)
		{
			formatex(szSound, 63/*iSizeSounds - 1*/, "%s.wav", g_szSoundSpecial)
			precache_sound(szSound)
		}
	}
	
	if (g_bIsMp3SoundNormal)
		precache_generic(g_szSoundNormal)
	
	if (g_bIsMp3SoundSpecial)
		precache_generic(g_szSoundSpecial)
}

public plugin_init()
{
	register_plugin("[ZPNM] Special Chat", "1.8.2", "D i 5 7 i n c T, Speed")
	
	register_dictionary("zpnm_special_chat.txt")
	
	register_message(get_user_msgid("TeamInfo"), "message_teaminfo")
	
	register_clcmd("say", "clcmd_sayall")
	register_clcmd("say_team", "clcmd_sayteam")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_iMaxPlayers = get_maxplayers();
}

public plugin_cfg()
	set_task(1.57, "d7_cache_settings")

public d7_cache_settings()
{
	g_fFloodTime = get_cvar_float("amx_flood_time");
	
	if (g_fFloodTime > 0.0)
		return;
	
	g_fFloodTime = 0.5;
}

public client_putinserver(iID)
{
	g_bCanChat[iID] = true;
	
	zpnm_get_class_name(1, 0, g_szClass[iID], 31)
	
	static szIp[16];
	get_user_ip(iID, szIp, 15)
	
	geoip_code3_ex(szIp, g_szCountry[iID])
	
	if (!g_szCountry[iID][0])
		g_szCountry[iID] = "N/A";
}

public client_disconnect(iID)
{
	remove_task(iID)
	
	g_bAlive[iID] = false;
	g_bCanChat[iID] = false;
}

public message_teaminfo(msg_id, msg_dest)
{
	// Only hook global messages
	if (msg_dest != MSG_ALL && msg_dest != MSG_BROADCAST)
		return;
	
	// Get player iID and his new team
	static szTeam[2], iID;
	
	get_msg_arg_string(2, szTeam, 1)
	
	iID = get_msg_arg_int(1);
	
	if (szTeam[0] == 'S' || szTeam[0] == 'U')
	{
		g_iTeam[iID] = 0;
		g_szMlStatus[iID] = "ZPNM_SPECTATING";
	}
	else
	{
		if (g_bAlive[iID])
			g_szMlStatus[iID] = "ZPNM_ALIVE";
		else
		{
			g_szMlStatus[iID] = "ZPNM_DEAD";
			
			// Only consider when joining from unassigned or spec(available
			// once per round by default) to avoid spying on enemy team's chat
			if (!g_iTeam[iID])
			{
				if (szTeam[0] == 'C')
					g_iTeam[iID] = 1;
				else if (szTeam[0] == 'T')
					g_iTeam[iID] = 2;
			}
		}
	}
}

public client_infochanged(iID)
{
	if (!is_user_connected(iID))
		return;
/*=====	
	static szName[31];
	get_user_info(iID, "name", szName, 30)
	
	if (equali(g_szName[iID], szName))
		return;
=======*/
	
	get_user_info(iID, "name", g_szName[iID], 30)
	
	if (get_user_flags(iID) & ADMIN_CHAT)
		g_szColor[iID] = "^4";
	else
		g_szColor[iID] = "";
}

public zpnm_user_spawn_post(iID)
{
	g_iTeam[iID] = 1;
	g_bAlive[iID] = true;
	g_szMlStatus[iID] = "ZPNM_ALIVE";
	
	zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], 31)
}

public zp_user_infected_post(iID, infector, nemesis, assassin)
{
	g_iTeam[iID] = 2;
	
	if (!assassin)
	{
		if (!nemesis)
			zpnm_get_class_name(0, zp_get_user_zombie_class(iID), g_szClass[iID], 31)
		else
			g_szClass[iID] = "CLASS_NEMESIS";
	}
	else
		g_szClass[iID] = "CLASS_ASSASSIN";
}

public zp_user_humanized_post(iID, survivor, sniper)
{
	g_iTeam[iID] = 1;
	
	if (!sniper)
	{
		if (!survivor)
			zpnm_get_class_name(1, zpnm_get_user_human_class(iID), g_szClass[iID], 31)
		else
			g_szClass[iID] = "CLASS_SURVIVOR";
	}
	else
		g_szClass[iID] = "CLASS_SNIPER";
}

public fwHamKilledPlayer(const iID)
{
	g_bAlive[iID] = false;
	g_szMlStatus[iID] = "ZPNM_DEAD";
}

d7_play_sound(const iSender, const iTarget)
{
	if (!g_szColor[iSender][0])
		client_cmd(iTarget, "%s ^"%s^"", !g_bIsMp3SoundNormal ? "spk" : "mp3 play", g_szSoundNormal)
	else
		client_cmd(iTarget, "%s ^"%s^"", !g_bIsMp3SoundSpecial ? "spk" : "mp3 play", g_szSoundSpecial)
}

public clcmd_sayall(iID)
{
	if (!g_bCanChat[iID])
	{
		colored_print(iID, iID, "%s ^3%L^1!", D7_CHAT_TAG, iID, "ZPNM_FLOOD")
		
		return PLUGIN_HANDLED_MAIN;
	}
	
	static szArg[192];
	read_args(szArg, 191)
	
	trim(szArg)
	remove_quotes(szArg)
	replace_all(szArg, 191, "%", "")
	
	if(!szArg[0])
		return PLUGIN_HANDLED_MAIN;
	
	new id2;
	
	if (containi(g_szClass[iID], "CLASS_") == -1)
	{
		for (id2 = 1; id2 <= g_iMaxPlayers; id2++)
		{
			colored_print(id2, iID, "^1%L[^4%s^1][^4%s^1]%s ^3%s^1: %s%s", id2, g_szMlStatus[iID], g_szCountry[iID],
			g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			
			d7_play_sound(iID, id2)
		}
	}
	else
	{
		for (id2 = 1; id2 <= g_iMaxPlayers; id2++)
		{
			colored_print(id2, iID, "^1%L[^4%s^1][^4%L^1]%s ^3%s^1: %s%s", id2, g_szMlStatus[iID], g_szCountry[iID],
			id2, g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			
			d7_play_sound(iID, id2)
		}
	}
	
	if (!g_szColor[iID][0])
	{
		g_bCanChat[iID] = false;
		
		remove_task(iID)
		set_task(g_fFloodTime, "d7_allow_chat", iID)
	}
	
	return PLUGIN_HANDLED_MAIN;
}

public clcmd_sayteam(iID)
{
	if (!g_bCanChat[iID])
	{
		colored_print(iID, iID, "%s ^3%L^1!", D7_CHAT_TAG, iID, "ZPNM_FLOOD")
		
		return PLUGIN_HANDLED_MAIN;
	}
	
	static szArg[192];
	read_args(szArg, 191)
	
	trim(szArg)
	remove_quotes(szArg)
	replace_all(szArg, 191, "%", "")
	
	if(!szArg[0])
		return PLUGIN_HANDLED_MAIN;
	
	new id2;
	
	if (containi(g_szClass[iID], "CLASS_") == -1)
	{
		for (id2 = 1; id2 <= g_iMaxPlayers; id2++)
		{
			if (g_iTeam[iID] != g_iTeam[id2] || g_bAlive[iID] != g_bAlive[id2])
				continue;
			
			if (g_iTeam[iID])
			{
				colored_print(id2, iID, "^1%L(%L)[^4%s^1][^4%s^1]%s ^3%s^1: %s%s", id2, g_szMlStatus[iID], id2, g_iTeam[iID] > 1 ? "ZPNM_ZOMBIES"
				: "ZPNM_HUMANS", g_szCountry[iID], g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			}
			else
			{
				colored_print(id2, iID, "^1(%L)[^4%s^1][^4%s^1]%s ^3%s^1: %s%s", id2, "ZPNM_SPECTATORS", g_szCountry[iID],
				g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			}
			
			d7_play_sound(iID, id2)
		}
	}
	else
	{
		for (id2 = 1; id2 <= g_iMaxPlayers; id2++)
		{
			if (g_iTeam[iID] != g_iTeam[id2] || g_bAlive[iID] != g_bAlive[id2])
				continue;
			
			if (g_iTeam[iID])
			{
				colored_print(id2, iID, "^1%L(%L)[^4%s^1][^4%L^1]%s ^3%s^1: %s%s", id2, g_szMlStatus[iID], id2, g_iTeam[iID] > 1 ? "ZPNM_ZOMBIES"
				: "ZPNM_HUMANS", g_szCountry[iID], id2, g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			}
			else
			{
				colored_print(id2, iID, "^1(%L)[^4%s^1][^4%L^1]%s ^3%s^1: %s%s", id2, "ZPNM_SPECTATORS", g_szCountry[iID],
				id2, g_szClass[iID], !g_szColor[iID][0] ? "" : D7_CHAT_SPECIAL_TAG, g_szName[iID], g_szColor[iID], szArg)
			}
			
			d7_play_sound(iID, id2)
		}
	}
	
	if (!g_szColor[iID][0])
	{
		g_bCanChat[iID] = false;
		
		remove_task(iID)
		set_task(g_fFloodTime, "d7_allow_chat", iID)
	}
	
	return PLUGIN_HANDLED_MAIN;
}

colored_print(const iTarget, const iSender, const szMessage[], any:...)
{
	if (!is_user_connected(iTarget))
		return;
	
	static szBuffer[192];
	
	// Format message for player
	vformat(szBuffer, 191, szMessage, 4)
	
	static msgSayText;
	
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	message_begin(MSG_ONE_UNRELIABLE, msgSayText, _, iTarget)
	write_byte(iSender)
	write_string(szBuffer)
	message_end()
}

public d7_allow_chat(const iID)
	g_bCanChat[iID] = true
