/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.1.2
[ ] 
*/

// Modules
#include <amxmodx>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <zp50_colorchat>

// Biohazard Human Attributes
new const hclass_bio_name[] = "Biohazard Human"
new const hclass_bio_info[] = "Immune to infection grenades"
new const hclass_bio_model[] = "sas"
new const hclass_bio_handmodel[] = "v_knife.mdl"
const hclass_bio_health = 100
const hclass_bio_speed = 240
const Float:hclass_bio_gravity = 1.0

new g_hclass_bio, g_MaskBlocks[33], cvar_nob

public plugin_init()
{
	register_plugin("[ZPNM] Biohazard Human Class", "1.1.2", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_hclass_biohazard.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_nob = register_cvar("zpnm_bio_human_blocks", "1")
}

public plugin_precache()
	g_hclass_bio = zpnm_register_human_class(hclass_bio_name, hclass_bio_info, hclass_bio_model, hclass_bio_handmodel, hclass_bio_health, hclass_bio_speed, hclass_bio_gravity)

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
	cvar_nob = get_pcvar_num(cvar_nob)

public client_disconnect(iID)
	if (cvar_nob)
		g_MaskBlocks[iID] = 0

public zpnm_user_spawn_post(iID)
{
	if (zpnm_get_user_human_class(iID) != g_hclass_bio)
		return;
	
	if (cvar_nob < 1)
		client_print(iID, print_center, "%L", iID, "BIO_IMMUNITY")
	else
	{
		g_MaskBlocks[iID] = cvar_nob
		client_print(iID, print_center, "%L", iID, "BIO_IMMUNITY_COUNT", g_MaskBlocks[iID])
	}
}

public zp_user_infect_attempt(iID, infector, nem, ass, nade)
{
	if (!nade || !infector)
		return PLUGIN_CONTINUE;
	
	if (cvar_nob)
	{
		if (!g_MaskBlocks[iID])
			return PLUGIN_CONTINUE;
		
		g_MaskBlocks[iID]--
		
		if (!g_MaskBlocks[iID])
			client_print(iID, print_center, "%L", iID, "BIO_NO_IMMUNITY")
		else
			client_print(iID, print_center, "%L", iID, "BIO_IMMUNITY_COUNT", g_MaskBlocks[iID])
	}
	else
	{
		client_print(iID, print_center, "%L", iID, "BIO_BLOCK_MSG")
		client_print(infector, print_center, "%L", infector, "BIO_INFECTOR_MSG")
	}
	
	return ZP_PLUGIN_HANDLED;
}

public zp_user_infected_post(iID)
	g_MaskBlocks[iID] = 0

public zp_user_humanized_post(iID, survivor, sniper)
{
	if (zpnm_get_user_human_class(iID) != g_hclass_bio || survivor || sniper)
		return;
	
	if (cvar_nob < 1)
		client_print(iID, print_center, "%L", iID, "BIO_IMMUNITY")
	else
	{
		g_MaskBlocks[iID] = cvar_nob
		client_print(iID, print_center, "%L", iID, "BIO_IMMUNITY_COUNT", g_MaskBlocks[iID])
	}
}

public fwHamKilledPlayer(const iID)
	g_MaskBlocks[iID] = 0
