/*
To do:

T = needs testing
X = done
- = cancelled

[T] CZ bots support
v1.6.2
[T] only allow picking up a new armor if player has 0
[T] make sure armor is not set lower than 0
v1.6.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fun>
#include <cstrike>
#include <hamsandwich>

// Plug-in APIs
#include <amx_settings_api>
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Maximum lenght of the sound directory and file name(-1. For example 63 is actually 64.)
const g_iMaxSoundPathLenght = 63;

new Array:g_aSoundsArmor, Array:g_aSoundsHealth;

new g_iClassID, cvar_reward, cvar_convert, g_iMaxPlayers, g_bSoldier[33];

const g_cNoRound = -2;
const g_cKillRound = -1;
const g_cInfectionRound = 0;

new g_iRoundTypeAndLastHumanID = g_cNoRound;

public plugin_precache()
{
	// Soldier Human Attributes
	new const hclass_soldier_name[] = "Soldier Human"
	new const hclass_soldier_info[] = "Armor or health for kill"
	new const hclass_soldier_model[] = "urban"
	new const hclass_soldier_handmodel[] = "v_knife.mdl"
	const hclass_soldier_health = 100
	const hclass_soldier_speed = 240
	const Float:hclass_soldier_gravity = 1.0
	
	g_iClassID = zpnm_register_human_class(hclass_soldier_name, hclass_soldier_info, hclass_soldier_model, hclass_soldier_handmodel, hclass_soldier_health, hclass_soldier_speed, hclass_soldier_gravity)
	
	new const szSettingsFile[] = "zpnm_hclass_soldier.ini"
	new const szSoundsSection[] = "Sounds"
	new const szSoundsArmor[] = "ARMOR"
	new const szSoundsHealth[] = "HEALTH"
	
	g_aSoundsArmor = ArrayCreate(g_iMaxSoundPathLenght + 1, 1);
	g_aSoundsHealth = ArrayCreate(g_iMaxSoundPathLenght + 1, 1);
	
	amx_load_setting_string_arr(szSettingsFile, szSoundsSection, szSoundsArmor, g_aSoundsArmor)
	amx_load_setting_string_arr(szSettingsFile, szSoundsSection, szSoundsHealth, g_aSoundsHealth)
	
	new iArraySize;
	
	if ((iArraySize = ArraySize(g_aSoundsArmor)) == 0)
	{
		new const szSoundArmor[] = "items/ammopickup2.wav"
		
		ArrayPushString(g_aSoundsArmor, szSoundArmor)
		
		iArraySize = 1;
		
		amx_save_setting_string_arr(szSettingsFile, szSoundsSection, szSoundsArmor, g_aSoundsArmor)
	}
	
	new i, szString[g_iMaxSoundPathLenght + 1];
	
	for (i = 0; i < iArraySize; i++)
	{
		ArrayGetString(g_aSoundsArmor, i, szString, g_iMaxSoundPathLenght)
		
		precache_sound(szString)
	}
	
	if ((iArraySize = ArraySize(g_aSoundsHealth)) == 0)
	{
		new const szSoundHealth[] = "items/smallmedkit1.wav"
		
		ArrayPushString(g_aSoundsHealth, szSoundHealth)
		
		iArraySize = 1;
		
		amx_save_setting_string_arr(szSettingsFile, szSoundsSection, szSoundsHealth, g_aSoundsHealth)
	}
	
	for (i = 0; i < iArraySize; i++)
	{
		ArrayGetString(g_aSoundsHealth, i, szString, g_iMaxSoundPathLenght)
		
		precache_sound(szString)
	}
}

public plugin_init()
{
	register_plugin("[ZPNM] Soldier Human Class", "1.6.3", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_hclass_soldier.txt")
	
	register_event("Battery", "event_armor", "be")
	register_event("Health", "event_health", "be")
	
//	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	cvar_reward = register_cvar("zpnm_soldier_reward", "35")
	cvar_convert = register_cvar("zpnm_soldier_convert", "0")
	
	g_iMaxPlayers = get_maxplayers();
}

public client_disconnect(id)
{
	remove_task(id)
	g_bSoldier[id] = false;
	
	if (id == g_iRoundTypeAndLastHumanID)
		g_iRoundTypeAndLastHumanID = g_cInfectionRound;
}

public event_armor(id)
{
	if (g_iRoundTypeAndLastHumanID == g_cNoRound || g_iRoundTypeAndLastHumanID == g_cInfectionRound)
		return;
	
	remove_task(id)
	set_task(0.1, "zpnm_convert_to_health_or_armor", id)
}

public event_health(id)
{
	if (g_iRoundTypeAndLastHumanID == g_cKillRound || g_iRoundTypeAndLastHumanID > g_cInfectionRound)
		return;
	
	remove_task(id)
	set_task(0.1, "zpnm_convert_to_health_or_armor", id)
}

public zpnm_user_spawn_post(id) //fw_PlayerSpawn_Post
{
//	if (!is_user_alive(id))
//		return;
//	
	remove_task(id)
	
	if (zpnm_get_user_human_class(id) != g_iClassID)
		g_bSoldier[id] = false;
	else
	{
		g_bSoldier[id] = true;
		
		zpnm_convert_to_health_or_armor(id)
	}
	
	if (g_iRoundTypeAndLastHumanID < 1)
		return;
	
	zpnm_convert_to_health_or_armor(g_iRoundTypeAndLastHumanID)
	
	g_iRoundTypeAndLastHumanID = g_cInfectionRound;
}

public zp_round_started(mode)
{
	if (mode == MODE_INFECTION || mode == MODE_MULTI)
		g_iRoundTypeAndLastHumanID = g_cInfectionRound;
	else
		g_iRoundTypeAndLastHumanID = g_cKillRound;
	
	zpnm_global_convert()
}

public zp_user_infected_post(id)
	g_bSoldier[id] = false;

public zp_user_humanized_pre(id)
{
	if (g_iRoundTypeAndLastHumanID < 1 || !zp_get_user_zombie(id))
		return;
	
	zpnm_convert_to_health_or_armor(g_iRoundTypeAndLastHumanID)
	
	g_iRoundTypeAndLastHumanID = g_cInfectionRound;
}

public zp_user_humanized_post(id, survivor, sniper)
	if (survivor || sniper || zpnm_get_user_human_class(id) != g_iClassID)
		g_bSoldier[id] = false;
	else
	{
		g_bSoldier[id] = true;
		
		zpnm_convert_to_health_or_armor(id)
	}

public zp_user_last_human(id)
{
	client_print(0, print_console, "Last human with ID #%d.", id)
	
	if (g_iRoundTypeAndLastHumanID != g_cInfectionRound)
	{
		client_print(0, print_console, "Is NOT infection round.")
		
		return;
	}
	
	client_print(0, print_console, "Is infection round. Calling the convert function for last human with ID #%d.", id)
	
	g_iRoundTypeAndLastHumanID = id;
	
	zpnm_convert_to_health_or_armor(id)
}

public fwHamKilledPlayer(const iVictim, const iAttacker)
{
	remove_task(iVictim)
	g_bSoldier[iVictim] = false;
	
	if (iAttacker < 1 || iAttacker > g_iMaxPlayers || iVictim == iAttacker || !g_bSoldier[iAttacker] || !zp_get_user_zombie(iVictim))
		return;
	
	new iReward = get_pcvar_num(cvar_reward);
	
	if (!iReward)
		return;
	
	if (g_iRoundTypeAndLastHumanID == g_cInfectionRound || g_iRoundTypeAndLastHumanID == g_cNoRound)
	{
		zpnm_give_health_or_armor(iAttacker, true, iReward)
		colored_chat(iAttacker, "^4%L", iAttacker, "ZPNM_GET_ARMOR", iReward)
	}
	else if (g_iRoundTypeAndLastHumanID == g_cKillRound || g_iRoundTypeAndLastHumanID > g_cInfectionRound)
	{
		zpnm_give_health_or_armor(iAttacker, false, iReward)
		colored_chat(iAttacker, "^4%L", iAttacker, "ZPNM_GET_HEALTH", iReward)
	}
}

public zp_round_ended()
{
	g_iRoundTypeAndLastHumanID = g_cNoRound;
	
	zpnm_global_convert()
}

zpnm_global_convert()
	if (get_pcvar_num(cvar_convert))
		for (new i = 1; i <= g_iMaxPlayers; i++)
			zpnm_convert_to_health_or_armor(i)

public zpnm_convert_to_health_or_armor(const iID)
{
	if (!g_bSoldier[iID] || !get_pcvar_num(cvar_convert))
		return;
	
	new iAmount;
	
	if (g_iRoundTypeAndLastHumanID == g_cNoRound || g_iRoundTypeAndLastHumanID == g_cInfectionRound)
	{
		static iMaxHP;
		if (!iMaxHP)
			iMaxHP = zpnm_get_human_maxhealth(iID)
		
		iAmount = get_user_health(iID) - iMaxHP;
		
		if (iAmount < 1)
			return;
		
		set_user_health(iID, iMaxHP)
		zpnm_give_health_or_armor(iID, true, iAmount)
		
		colored_chat(iID, "^4%L", iID, "ZPNM_CONVERTED_TO_ARMOR", iAmount)
	}
	else if (g_iRoundTypeAndLastHumanID == g_cKillRound || g_iRoundTypeAndLastHumanID > g_cInfectionRound)
	{
		iAmount = get_user_armor(iID);
		
		if (iAmount < 1)
			return;
		
		cs_set_user_armor(iID, 0, CS_ARMOR_NONE)
		zpnm_give_health_or_armor(iID, false, iAmount)
		
		colored_chat(iID, "^4%L", iID, "ZPNM_CONVERTED_TO_HEALTH", iAmount)
	}
}

zpnm_give_health_or_armor(const iID, const bArmor, const iAmount)
{
	static szSound[g_iMaxSoundPathLenght + 1];
	
	if (bArmor)
	{
		if (iAmount > 0)
			cs_set_user_armor(iID, get_user_armor(iID) + iAmount, CS_ARMOR_VESTHELM)
		else
			cs_set_user_armor(iID, 0, CS_ARMOR_NONE)
		
		static iSizeArmor;
		if (!iSizeArmor)
			iSizeArmor = ArraySize(g_aSoundsArmor) - 1;
		
		ArrayGetString(g_aSoundsArmor, random_num(0, iSizeArmor), szSound, g_iMaxSoundPathLenght)
		
		emit_sound(iID, CHAN_BODY, szSound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	else
	{
		set_user_health(iID, get_user_health(iID) + iAmount)
		
		static iSizeHealth;
		if (!iSizeHealth)
			iSizeHealth = ArraySize(g_aSoundsHealth) - 1;
		
		ArrayGetString(g_aSoundsHealth, random_num(0, iSizeHealth), szSound, g_iMaxSoundPathLenght)
		
		emit_sound(iID, CHAN_BODY, szSound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
}

colored_chat(const iTarget, const szMessage[], any:...)
{
	if (!is_user_connected(iTarget))
		return;
	
	static szBuffer[192];
	
	// Format message for player
	vformat(szBuffer, 191, szMessage, 3)
	
	static const D7_CHAT_TAG[] = "^1[^4ZPNM^1] ";
	
	format(szBuffer, 191, "%s%s", D7_CHAT_TAG, szBuffer)
	
	static msgSayText;
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	message_begin(MSG_ONE, msgSayText, _, iTarget)
	write_byte(iTarget)
	write_string(szBuffer)
	message_end()
}
