/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.2.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Soldier Zombie Attributes
new const zclass_soldier_name[] = "Soldier Zombie" // name
new const zclass_soldier_info[] = "Takes less damage" // description
new const zclass_soldier_model[] = "zombie_source" // model
new const zclass_soldier_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_soldier_health = 1800 // health
const zclass_soldier_speed = 190 // speed
const Float:zclass_soldier_gravity = 1.157 // gravity
const Float:zclass_soldier_knockback = 0.757 // knockback

new const g_helmet_hit_sound[] = "player/bhit_helmet-1.wav"
new const g_kevlar_hit_sound[] = "player/bhit_kevlar-1.wav"

// Class IDs
new g_zclass_soldier

new g_cvar_damage, g_soldier[33], Float:g_damage

public plugin_init()
{
	register_plugin("[ZPNM] Soldier Zombie", "1.2.3", "D i 5 7 i n c T")
	
	RegisterHam(Ham_TraceAttack, "player", "fw_TraceAttack")
	RegisterHamBots(Ham_TraceAttack, "fw_TraceAttack")
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	g_cvar_damage = register_cvar("zpnm_soldier_zombie_damage", "0.75")
}

public plugin_precache()
{
	// Register all classes
	g_zclass_soldier = zp_register_zombie_class(zclass_soldier_name, zclass_soldier_info, zclass_soldier_model, zclass_soldier_clawmodel, zclass_soldier_health, zclass_soldier_speed, zclass_soldier_gravity, zclass_soldier_knockback)	
	
	precache_sound(g_helmet_hit_sound)
	precache_sound(g_kevlar_hit_sound)
}

public plugin_cfg()
	g_damage = get_pcvar_float(g_cvar_damage)

public client_disconnect(id)
	g_soldier[id] = false

public zpnm_user_spawn_post(id)
	g_soldier[id] = false

public zp_user_infected_post(id, nemesis, assassin)
{
	if (nemesis || assassin || zp_get_user_zombie_class(id) != g_zclass_soldier)
		return;
	
	g_soldier[id] = true
}

public zp_user_humanized_post(id)
	g_soldier[id] = false

public fwHamKilledPlayer(id)
	g_soldier[id] = false

public fw_TraceAttack(id, attacker, Float:damage, Float:direction[3], tracehandle, damage_type)
{
	if (!g_soldier[id])
		return;
	
	damage *= g_damage
	SetHamParamFloat(3, damage)
	
	if (get_tr2(tracehandle, TR_iHitgroup) == HIT_HEAD)
		emit_sound(id, CHAN_BODY, g_helmet_hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	else
		emit_sound(id, CHAN_BODY, g_kevlar_hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
}
