/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
v1.3.3
[ ] 
*/

// Modules
#include <amxmodx>
#include <fun>
#include <engine>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <dhudmessage>

#define TASK_RENDER 57
#define TASK_DAMAGE 75

// Radioactive Zombie Attributes
new const zclass_rage_name[] = "Radioactive Zombie" // name
new const zclass_rage_info[] = "Toxic radiation(damage on touch)" // description
new const zclass_rage_model[] = "zombie_source" // model
new const zclass_rage_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_rage_health = 2000 // health
const zclass_rage_speed = 200 // speed
const Float:zclass_rage_gravity = 0.757 // gravity
const Float:zclass_rage_knockback = 1.357 // knockback

new const g_kevlar_hit_sound[] = "player/bhit_kevlar-1.wav"
//new const g_flesh_hit_sound[] = "player/bhit_flesh-1.wav"

new pcvar_interval, pcvar_damage, /*pcvar_infect, */pcvar_color_r, pcvar_color_g, pcvar_color_b
new g_zclass_radioactive, g_radioactive[33], g_no_damage[33], g_nem_color[3], Float:g_interval

public plugin_init()
{
	register_plugin("[ZPNM] Radioactive Zombie", "1.3.3", "D i 5 7 i n c T, NiHiLaNTh")
	register_touch("player", "player", "zpnm_user_touched")
	register_dictionary("zpnm_zclass_radioactive.txt")
	
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	
	pcvar_interval = register_cvar("zpnm_radioactive_dmg_interval", "1.57")
	pcvar_damage = register_cvar("zpnm_radioactive_dmg_amount", "7")
//	pcvar_infect = register_cvar("zpnm_radioactive_dmg_infect", "1")
	pcvar_color_r = register_cvar("zpnm_radioactive_color_r", "0")
	pcvar_color_g = register_cvar("zpnm_radioactive_color_g", "255")
	pcvar_color_b = register_cvar("zpnm_radioactive_color_b", "0")
}

public plugin_precache()
{
	// Register all classes
	g_zclass_radioactive = zp_register_zombie_class(zclass_rage_name, zclass_rage_info, zclass_rage_model, zclass_rage_clawmodel, zclass_rage_health, zclass_rage_speed, zclass_rage_gravity, zclass_rage_knockback)
	
	precache_sound(g_kevlar_hit_sound)
//	precache_sound(g_flesh_hit_sound)
}

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	g_interval = get_pcvar_float(pcvar_interval)
	pcvar_damage = get_pcvar_num(pcvar_damage)
	
	g_nem_color[0] = get_pcvar_num(get_cvar_pointer("zp_nvg_nem_color_R"))
	g_nem_color[1] = get_pcvar_num(get_cvar_pointer("zp_nvg_nem_color_G"))
	g_nem_color[2] = get_pcvar_num(get_cvar_pointer("zp_nvg_nem_color_B"))
}

public client_disconnect(iID)
{
	remove_task(iID + TASK_RENDER)
	remove_task(iID + TASK_DAMAGE)
	
	g_radioactive[iID] = false
}

public zpnm_user_spawn_post(iID)
	g_radioactive[iID] = false

public zp_user_infected_post(iID, infector, nemesis, assassin)
{
	if (zp_get_user_zombie_class(iID) != g_zclass_radioactive)
		return;
	
	if (nemesis)
	{
		if (!get_pcvar_num(get_cvar_pointer("zp_nem_glow")))
			set_user_rendering(iID)
		
		return;
	}
	else if (assassin)
	{
		if (!get_pcvar_num(get_cvar_pointer("zpnm_ass_glow")))
			set_user_rendering(iID)
		
		return;
	}
	
	g_radioactive[iID] = true
	set_user_rendering(iID, kRenderFxGlowShell, get_pcvar_num(pcvar_color_r), get_pcvar_num(pcvar_color_g), get_pcvar_num(pcvar_color_b), kRenderNormal, 0)
}

public zp_user_unfrozen(iID)
	if (g_radioactive[iID])
	{
		if (!zpnm_get_user_no_damage(iID))
			set_user_rendering(iID, kRenderFxGlowShell, get_pcvar_num(pcvar_color_r), get_pcvar_num(pcvar_color_g), get_pcvar_num(pcvar_color_b), kRenderNormal, 0)
		else
			set_user_rendering(iID, kRenderFxGlowShell, g_nem_color[0], g_nem_color[1], g_nem_color[2], kRenderNormal, 0)
	}

public zp_user_humanized_post(iID, survivor, sniper)
{
	if (!g_radioactive[iID])
		return;
	
	if (survivor)
	{
		if (!get_pcvar_num(get_cvar_pointer("zp_surv_glow")))
			set_user_rendering(iID)
		
		return;
	}
	else if (sniper)
	{
		if (!get_pcvar_num(get_cvar_pointer("zpnm_snip_glow")))
			set_user_rendering(iID)
		
		return;
	}
	else
		set_user_rendering(iID)
	
	g_radioactive[iID] = false
}

public fwHamKilledPlayer(const iID)
	g_radioactive[iID] = false

public zp_extra_item_selected(iID, itemid)
{
	if (!g_radioactive[iID] || itemid != EXTRA_MADNESS)
		return;
	
	if (!zpnm_get_user_frozen(iID))
		set_user_rendering(iID, kRenderFxGlowShell, g_nem_color[0], g_nem_color[1], g_nem_color[2], kRenderNormal, 0)
	
	set_task(get_pcvar_float(get_cvar_pointer("zp_extra_madness_duration")), "zpnm_reset_glow", iID + TASK_RENDER)
}

public zpnm_reset_glow(taskid)
{
	static iID
	iID = taskid - TASK_RENDER
	
	if (!zpnm_get_user_frozen(iID))
		set_user_rendering(iID, kRenderFxGlowShell, get_pcvar_num(pcvar_color_r), get_pcvar_num(pcvar_color_g), get_pcvar_num(pcvar_color_b), kRenderNormal, 0)
}

public zpnm_user_touched(iID, zm)
{
	if (!g_radioactive[zm] || g_no_damage[zm] || !is_user_alive(iID) || zp_get_user_zombie(iID) || zpnm_get_user_frozen(zm))
		return;
	
	static armor
	armor = get_user_armor(iID)
	
	if (armor)
	{
		zpnm_set_user_armor(iID, armor - pcvar_damage)
		emit_sound(iID, CHAN_BODY, g_kevlar_hit_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		set_dhudmessage(255, 0, 0, 0.0, 0.57, 1, 1.757, 3.157, 0.1, 2.0)
		show_dhudmessage(iID, "%L^n%L", iID, "ZPNM_RADIOACTIVE_ARMOR", iID, "ZPNM_RADIOACTIVE_CONTACT")
	}
/*	else if (!zp_get_user_last_human(iID) && !zp_get_user_survivor(iID) && !zpnm_get_user_sniper(iID)
	&& !zp_is_swarm_round() && !zp_is_plague_round())
	{
		zp_infect_user(iID, zm, 0, 1)
		
		set_dhudmessage(255, 255, 0, 0.0001, -1.0, 1, 2.757, 3.157, 0.1, 2.0)
		show_dhudmessage(iID, "%L", iID, "ZPNM_RADIOACTIVE_INFECT")
	}*/
	else
	{
		if (!zp_get_user_survivor(iID) && !zpnm_get_user_sniper(iID))
			ExecuteHam(Ham_TakeDamage, iID, zm, zm, float(pcvar_damage), DMG_NERVEGAS)
		else
			ExecuteHamB(Ham_TakeDamage, iID, zm, zm, float(pcvar_damage), DMG_NERVEGAS)
		
		set_dhudmessage(255, 0, 0, 0.0, 0.57, 1, g_interval, 3.157, 0.1, 2.0)
		show_dhudmessage(iID, "%L^n%L", iID, "ZPNM_RADIOACTIVE_HEALTH", iID, "ZPNM_RADIOACTIVE_CONTACT")
	}
	
	g_no_damage[zm] = true
	
	remove_task(zm + TASK_DAMAGE)
	set_task(g_interval, "zpnm_allow_damage", zm + TASK_DAMAGE)
}

public zpnm_allow_damage(taskid)
	g_no_damage[taskid - TASK_DAMAGE] = false
